/**
 *
 * Copyright 2020 Tencent
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
import { Plugin, PluginServiceApi } from '@cloudbase/framework-core';
import { DenoBuilder } from './builder';
import { IFrameworkPluginDenoInputs } from './types';
declare class DenoPlugin extends Plugin {
    name: string;
    api: PluginServiceApi;
    inputs: IFrameworkPluginDenoInputs;
    protected resolvedInputs: IFrameworkPluginDenoInputs;
    protected buildOutput: any;
    protected denoBuilder: DenoBuilder;
    protected containerPlugin: any;
    constructor(name: string, api: PluginServiceApi, inputs: IFrameworkPluginDenoInputs);
    /**
     * 初始化资源
     */
    init(): Promise<void>;
    /**
     * 生成功能代码
     */
    genCode(): Promise<void>;
    /**
     * 构建资源
     */
    build(): Promise<void>;
    /**
     * 部署资源
     */
    deploy(): Promise<void>;
    /**
     * 将资源编译成 SAM 描述
     */
    compile(): Promise<any>;
    /**
     * 移除资源
     */
    remove(): Promise<void>;
    /**
     * 执行自定义命令
     */
    run(): Promise<void>;
}
export declare const plugin: typeof DenoPlugin;
export {};
//# sourceMappingURL=index.d.ts.map